var titles = {upper:'В', middle:'С', lower:'Н'};
var worlds = {upper:'Верхний мир', middle:'Средний мир', lower:'Нижний мир'};

jQuery(document).on('click', '.panel-heading', function(){
	jQuery(this).next('.panel-body').slideToggle(400);
});
jQuery(document).on('click', '.cards', function(){
	showShadowBox(jQuery(this).attr('shdbx-data'));
});

jQuery(document).ready(function() {
	jQuery('.panel-default .panel-body').slideUp(400);
	jQuery("input:lt(3)").on("focusout", function() {
    var val = Math.abs(parseInt(jQuery(this).val(), 10) || 0);
    jQuery(this).val(val > 9 ? 9 : val);
	});
	jQuery("input#all").on("focusout", function() {
    var val = Math.abs(parseInt(jQuery(this).val(), 10) || 0);
    jQuery(this).val(val > 27 ? 27 : val);
	});
	jQuery("input:lt(3)").on("change", function() {
    var val = Math.abs(parseInt(jQuery(this).val(), 10) || 0);
    jQuery(this).val(val > 9 ? 9 : val);
	});
	jQuery("input#all").on("change", function() {
    var val = Math.abs(parseInt(jQuery(this).val(), 10) || 0);
    jQuery(this).val(val > 27 ? 27 : val);
	});

	jQuery('#regenerate button.reg').click(function() {
		jQuery('#complex').html('');
		jQuery('.toggle-form').slideDown(400);
		jQuery('#regenerate').slideUp(400);
	});

	jQuery('#regenerate button.print').click(function() {popup_printable(jQuery('#complex'))});

	jQuery('form#generate button').click(
		function() {
			var sort = jQuery('input#sort').is(':checked');

			var upper = parseInt(jQuery('input#upper').val()) || 0;
			var middle = parseInt(jQuery('input#middle').val()) || 0;
			var lower = parseInt(jQuery('input#lower').val()) || 0;
			var all = parseInt(jQuery('input#all').val()) || 0;

			var upper_nums = pick(upper, 1, 9, sort);
			var middle_nums = pick(middle, 1, 9, sort);
			var lower_nums = pick(lower, 1, 9, sort);

			var all_nums = pick(all, 1, 27, sort);

			jQuery('#regenerate').slideDown(400);

			jQuery('#complex').html('');

			jQuery('#complex').append(generate_cards('upper', upper_nums));
			jQuery('#complex').append(generate_cards('middle', middle_nums));
			jQuery('#complex').append(generate_cards('lower', lower_nums));

			jQuery('#complex').append(generate_cards_full(all_nums));

			var compl = jQuery('#complex');

			jQuery('.toggle-form').slideUp(400);
			setTimeout(function() {jQuery('body').find('img').each(function() {detectLandscape(jQuery(this))})}, 500);
			return false;
		});

	Shadowbox.init();

});

function pick(quant, min, max, sort, no_repeats){
	if (!quant) return [];
	if (sort !== true) sort = false;
	if (typeof(no_repeats) === 'undefined') no_repeats = true;
	var values = [], i = max;
	while(i >= min) values.push(i--);
	var results = [];
	var maxIndex = max;
	for(i=1; i <= quant; i++){
		maxIndex--;
		var index = Math.floor(maxIndex * Math.random());
		results.push(values[index]); // no repeats
		if (no_repeats)
			values[index] = values[maxIndex];
//			results.push(index);
	}
	if (sort)
		return results.sort(function(a,b){return a-b;});
	else 
		return results;
}

function generate_cards (world, nums) {
	if(!world || !nums || nums.length == 0) return '';
	var code = '';


	code += '<div class="col-sm-12">';
	code += '<div class="panel panel-info">';
	code += '<div class="panel-heading" title="Нажмите чтоб свернуть/развернуть">';
	code += worlds[world];
	code += '</div>';
	code += '<div class="panel-body">';
	var just_opened = true;
	var open = false;
	for (var i=0;i<nums.length;i++) {
		if ((!just_opened && i % 4 === 0)) {
			code += '</div>';
			open = false;
		}
		just_opened = false;
		if (i % 4 === 0) {
			just_opened = true;
			code += '<div class="row card-row">';
			open = true;
		}
		code += '<div class="col-sm-3">';
		code += '<div class="img-wrap">';
		code += '<img class="cards" src="resources/' + world + '_world/images/' + nums[i]+ '.jpg" alt="' + titles[world] + nums[i] + '" title="' + titles[world] + nums[i] + '" shdbx-data="' + titles[world] + nums[i] + '_shdbx">';
		code += '<div class="img-overlay">';
		code += titles[world] + nums[i];
		code += '</div>';
		code += '</div>';

		code += '<div id="' + titles[world] + nums[i] + '_shdbx" style="display:none;" >';
		code += '<div class="sb-content">';
		code += '<h3>' + worlds[world] + '. Упражнение ' + nums[i] + '</h3>';
		code += '<div class="left">';
		code += '<img src="resources/' + world + '_world/images/' + nums[i]+ '.jpg" alt="' + titles[world] + nums[i] + '" title="' + titles[world] + nums[i] + '">';
		code += '</div>';
		code += '<div class="right">';
		code += '<p>';
		if (world == 'upper') {
			code += upper_texts[nums[i]];
		}
		if (world == 'middle') {
			code += middle_texts[nums[i]];
		}
		if (world == 'lower') {
			code += lower_texts[nums[i]];
		}
		code += '</p>';
		code += '</div>';
		code += '</div>';

		code += '</div>';
		code += '</div>';
	}
	if (open)
		code += '</div>';
	code += '</div>'; // panel-body
	code += '</div>'; // panel-info
	code += '</div><!-- col-sm-12 -->'; // col-sm-12
	return code;
}

function generate_cards_full (nums) {
	if(!nums || nums.length == 0) return '';

	var code = '';


	code += '<div class="col-sm-12">';
	code += '<div class="panel panel-info">';
	code += '<div class="panel-heading" title="Нажмите чтоб свернуть/развернуть">';
	code += 'Случайные карты из полной колоды';
	code += '</div>';
	code += '<div class="panel-body">';
	var just_opened = true;
	var open = false;
	for (var i=0;i<nums.length;i++) {
		var k = nums[i];
		if (k < 10) {
			world = 'upper';
		}
		else if (10 <= k && k < 19) {
			world = 'middle';
			k = k - 9;
		}
		else if (19 <= k && k <= 27) {
			world = 'lower';
			k = k - 18;
		}

		if ((!just_opened && i % 4 === 0)) {
			code += '</div>';
			open = false;
		}
		just_opened = false;
		if (i % 4 === 0) {
			just_opened = true;
			code += '<div class="row card-row">';
			open = true;
		}
		code += '<div class="col-sm-3">';
		code += '<div class="img-wrap">';
		code += '<img class="cards" src="resources/' + world + '_world/images/' + k + '.jpg" alt="' + titles[world] + k + '" title="' + titles[world] + k + '" shdbx-data="' + titles[world] + k + '_shdbx">';
		code += '<div class="img-overlay">';
		code += titles[world] + k;
		code += '</div>';
		code += '</div>';

		code += '<div id="' + titles[world] + k + '_shdbx" style="display:none;" >';
		code += '<div class="sb-content">';
		code += '<h3>' + worlds[world] + '. Упражнение ' + k + '</h3>';
		code += '<div class="left">';
		code += '<img src="resources/' + world + '_world/images/' + k + '.jpg" alt="' + titles[world] + k + '" title="' + titles[world] + k + '">';
		code += '</div>';
		code += '<div class="right">';
		code += '<p>';
		if (world == 'upper') {
			code += upper_texts[k];
		}
		if (world == 'middle') {
			code += middle_texts[k];
		}
		if (world == 'lower') {
			code += lower_texts[k];
		}
		code += '</p>';
		code += '</div>';
		code += '</div>';

		code += '</div>';
		code += '</div>';
	}
	if (open)
		code += '</div>';
	code += '</div>'; // panel-body
	code += '</div>'; // panel-info
	code += '</div><!-- col-sm-12 -->'; // col-sm-12
	return code;
}

function detectLandscape(img) {
  if(img.width() >= img.height()){
    img.parents('.img-wrap').addClass("landscape");
  } else {
    img.parents('.img-wrap').addClass("portrait");
  } 
}

function showShadowBox(id) {
	Shadowbox.open({
		content: jQuery('#' + id).clone().toggle().html(),
		player: 'html',
		height:550,
		width:700
	});
}

function get_printable_html (world, nums) {
	if(!world || !nums || nums.length == 0) return '';
	var code = '';

	code += '<div class="' + world + '">';
	code += '<h3>';
	code += worlds[world];
	code += '</h3>';
	code += '<div>';
	for (var i=0;i<nums.length;i++) {
		code += '<div class="printable img-wrap">';
		code += '<img class="printable cards" src="resources/' + world + '_world/images/' + nums[i]+ '.jpg" alt="' + titles[world] + nums[i] + '" title="' + titles[world] + nums[i] + '">';
		code += '<div class="img-overlay">';
		code += titles[world] + nums[i];
		code += '</div>';
		code += '</div>';
	}
	code += '</div>';
	code += '</div>';
	return code;
}

function popup_printable(obj) {
	var content = '<html lang="en"><head><meta charset="utf-8"><title>Сгенерировать комплекс упражнений</title><meta charset="utf-8"/><link href="resources/css/style.css" rel="stylesheet"/><script src="resources/js/jquery-1.11.0.min.js"></script><script src="resources/js/utility.js"></script></head><body><div id="complex">';
	content += obj.html();
	content += '</div><script>make_printable();</script>';
	content += '</body></html>';
	var w = window.open(location.href, 'Print');
	w.document.write(content);
	w.focus();
}

function make_printable() {
	jQuery('body > div').not('#complex').remove();
	jQuery('div#complex').addClass('print');
	jQuery('div.col-sm-3').addClass('print-col');
	jQuery('link[href="resources/css/bootstrap.min.css"]').remove();
	var styleSheets = document.styleSheets;
	var href = 'resources/css/bootstrap.min.css';
	for (var i = 0; i < styleSheets.length; i++) {
		if (styleSheets[i].href == href) {
			styleSheets[i].disabled = true;
			break;
		}
	}
}
